package io.renren.modules.sys.controller;

import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;

import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.security.controller.AbstractController;
import io.renren.modules.sys.dto.CompaniesDTO;
import io.renren.modules.sys.entity.CompaniesEntity;
import io.renren.modules.sys.entity.SysDeptEntity;
import io.renren.modules.sys.entity.SysUserEntity;
import io.renren.modules.sys.excel.CompaniesExcel;
import io.renren.modules.sys.service.CompaniesService;
import io.renren.modules.sys.service.ScopeCityCompanyService;
import io.renren.modules.sys.service.SysDeptService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import springfox.documentation.annotations.ApiIgnore;


/**
 * 公司表
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-29
 */
@RestController
@RequestMapping("sys/companies")
@Api(tags="公司表")
public class CompaniesController extends AbstractController{
    @Autowired
    private CompaniesService companiesService;
    
    @Autowired
    private ScopeCityCompanyService scopeCityCompanyService;
    
    @Autowired
    private SysDeptService sysDeptService;
    
    @Autowired
	private RedisTemplate<String, Object> redisTemplate;
    
    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:companies:page")
    public Result<PageData<CompaniesDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<CompaniesDTO> page = companiesService.page(params);
        for (CompaniesDTO dto : page.getList()) {
        	SysUserEntity creator = sysUserService.selectById(dto.getCreator());
        	if(null != creator) {
        		dto.setCreatorName(creator.getRealName());
        	}
        	
        	SysUserEntity update = sysUserService.selectById(dto.getUpdateBy());
        	if(null != update) {
        		dto.setUpdateName(update.getRealName());
        	}
        	
        	SysDeptEntity sysDept = sysDeptService.selectById(dto.getDeptId());
            if(null != sysDept) {
            	dto.setDeptName(sysDept.getName());
            }
        	
		}
        return new Result<PageData<CompaniesDTO>>().ok(page);
    }

    @GetMapping("list")
    @ApiOperation("列表")
    public Result<List<CompaniesDTO>> get(){
        List<CompaniesDTO> list = companiesService.getCompaniesListByUser();
        return new Result<List<CompaniesDTO>>().ok(list);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:companies:info")
    public Result<CompaniesDTO> get(@PathVariable("id") Long id){
        CompaniesDTO data = companiesService.get(id);
        SysDeptEntity sysDept = sysDeptService.selectById(data.getDeptId());
        if(null != sysDept) {
        	data.setDeptName(sysDept.getName());
        }
        return new Result<CompaniesDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:companies:save")
    public Result save(@RequestBody CompaniesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        companiesService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:companies:update")
    public Result update(@RequestBody CompaniesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        dto.setUpdateBy(getUserId());
        dto.setUpdateTime(new Date());
        companiesService.update(dto);
        
        List<String> scopeCityIds = scopeCityCompanyService.getScopeCityIdByCompanyId(dto.getId());
        redisTemplate.delete(scopeCityIds);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:companies:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        CompaniesEntity entity = new CompaniesEntity();
        entity.setStatus(Constant.Status.DISABLE.getValue());
        entity.setUpdateBy(getUserId());
        entity.setDeleteTime(new Date());
        companiesService.update(entity, new UpdateWrapper<CompaniesEntity>().in("id", ids));
        //companiesService.delete(ids);
        
        for (Long id : ids) {
        	List<String> scopeCityIds = scopeCityCompanyService.getScopeCityIdByCompanyId(id);
        	redisTemplate.delete(scopeCityIds);
		}

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:companies:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<CompaniesDTO> list = companiesService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, CompaniesExcel.class);
    }

}